package com.gyt.shr.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gyt.shr.entity.Person;
import com.gyt.shr.result.Result;
import javax.servlet.http.HttpServletRequest;

/**
* @author coyle
* @description
* @date 2025
 */
public interface PersonService extends IService<Person> {

//    /**
//     * 向指定手机号发送验证码
//     * @param phone 接收验证码的手机号
//     * @return 包含操作结果的Result对象，其中data字段为验证码长度
//     */
//    Result<Integer> sendCodeToPhone(String phone);



    /**
     * @description  根据手机号码查询是否存在有效用户
     */
    Result<Person>  checkPersonByPhone(String phone);


    /**
     * @description  面向普通管理员进行登录。
     * @param username 用户名
     * @param password 密码
     * @param request 用于提供服务的session信息
     * @return 返回标准的结果对象。
     */
    //普通管理员登录【完全体】
    Result<Integer> personLogin(String username, String password, HttpServletRequest request);

    /**
     * @description  面向普通管理员进行登出。
     * @param request 用于提供服务的session信息
     * @return 返回标准的结果对象。
     */
    //普通管理员登出【完全体】
    Result<Integer> userLogout(HttpServletRequest request);


}
